﻿using System;
using System.Collections;
using System.Configuration;
using System.Data;
using System.Linq;
using System.Web;
using System.Web.Security;
using System.Web.UI;
using System.Web.UI.HtmlControls;
using System.Web.UI.WebControls;
using System.Web.UI.WebControls.WebParts;
using System.Xml.Linq;
using ThinkGeo.MapSuite.Core;
using ThinkGeo.MapSuite.WebEdition;

namespace WebTemplate
{
    public partial class _Default : System.Web.UI.Page
    {
        protected void Page_Load(object sender, EventArgs e)
        {
            if (!Page.IsPostBack)
            {
                Map1.MapUnit = GeographyUnit.Meter;
                Map1.MapTools.MouseCoordinate.Enabled = true;
                //Map1.MapTools.OverlaySwitcher.Enabled = true;

                LayerOverlay blankOverlay = new LayerOverlay("BlankOverlay");
                blankOverlay.IsBaseOverlay = true;
                blankOverlay.IsVisible = true;
                Map1.CustomOverlays.Add(blankOverlay);

                GoogleOverlay googleOverlay = new GoogleOverlay("GoogleMap");
                googleOverlay.JavaScriptLibraryUri = new Uri(ConfigurationManager.AppSettings["GoogleUri"]);
                googleOverlay.GoogleMapType = GoogleMapType.Normal;
                googleOverlay.IsBaseOverlay = true;
                googleOverlay.IsVisible = true;
                Map1.CustomOverlays.Add(googleOverlay);

                GoogleOverlay googleSatelliteOverlay = new GoogleOverlay("GoogleSatHybridMap");
                googleSatelliteOverlay.JavaScriptLibraryUri = new Uri(ConfigurationManager.AppSettings["GoogleUri"]);
                googleSatelliteOverlay.GoogleMapType = GoogleMapType.Hybrid;
                googleSatelliteOverlay.IsBaseOverlay = true;
                googleSatelliteOverlay.IsVisible = true;
                Map1.CustomOverlays.Add(googleSatelliteOverlay);

                GoogleOverlay googleTerrainOverlay = new GoogleOverlay("GoogleTerrainMap");
                googleTerrainOverlay.JavaScriptLibraryUri = new Uri(ConfigurationManager.AppSettings["GoogleUri"]);
                googleTerrainOverlay.GoogleMapType = GoogleMapType.Physical;
                googleTerrainOverlay.IsBaseOverlay = true;
                googleTerrainOverlay.IsVisible = true;
                Map1.CustomOverlays.Add(googleTerrainOverlay);

                VirtualEarthOverlay veOverlay = new VirtualEarthOverlay("BingMap");
                veOverlay.JavaScriptLibraryUri = new Uri(ConfigurationManager.AppSettings["VEUri"]);
                veOverlay.VirtualEarthMapType = ThinkGeo.MapSuite.WebEdition.VirtualEarthMapType.Road;
                veOverlay.IsBaseOverlay = true;
                veOverlay.IsVisible = true;
                Map1.CustomOverlays.Add(veOverlay);

                VirtualEarthOverlay veSatelliteOverlay = new VirtualEarthOverlay("BingSatelliteMap");
                veSatelliteOverlay.JavaScriptLibraryUri = new Uri(ConfigurationManager.AppSettings["VEUri"]);
                veSatelliteOverlay.VirtualEarthMapType = ThinkGeo.MapSuite.WebEdition.VirtualEarthMapType.Hybrid;
                veSatelliteOverlay.IsBaseOverlay = true;
                veSatelliteOverlay.IsVisible = true;
                Map1.CustomOverlays.Add(veSatelliteOverlay);

                VirtualEarthOverlay veTerrainOverlay = new VirtualEarthOverlay("BingTerrainMap");
                veTerrainOverlay.JavaScriptLibraryUri = new Uri(ConfigurationManager.AppSettings["VEUri"]);
                veTerrainOverlay.VirtualEarthMapType = ThinkGeo.MapSuite.WebEdition.VirtualEarthMapType.Shaded;
                veTerrainOverlay.IsBaseOverlay = true;
                veTerrainOverlay.IsVisible = true;
                Map1.CustomOverlays.Add(veTerrainOverlay);

                WorldMapKitWmsWebOverlay worldMapKitOverlay = new WorldMapKitWmsWebOverlay("WMKMap");
                worldMapKitOverlay.Projection = WorldMapKitProjection.SphericalMercator;
                worldMapKitOverlay.IsBaseOverlay = true;
                worldMapKitOverlay.IsVisible = true;
                Map1.CustomOverlays.Add(worldMapKitOverlay);

                Map1.CurrentExtent = new RectangleShape(-10893992, 3941156, -10704160, 3798934);
            }
        }

        protected void BackgroundOptions_SelectedIndexChanged(object sender, EventArgs e)
        {
            string selectedMap = ((DropDownList)sender).SelectedValue;

            Map1.CustomOverlays["GoogleMap"].IsVisible = false;
            Map1.CustomOverlays["GoogleSatHybridMap"].IsVisible = false;
            Map1.CustomOverlays["GoogleTerrainMap"].IsVisible = false;
            Map1.CustomOverlays["BingMap"].IsVisible = false;
            Map1.CustomOverlays["BingSatelliteMap"].IsVisible = false;
            Map1.CustomOverlays["BingTerrainMap"].IsVisible = false;
            Map1.CustomOverlays["WMKMap"].IsVisible = false;

            if (selectedMap == "GoogleMap")
            {
                ((GoogleOverlay)Map1.CustomOverlays["GoogleMap"]).GoogleMapType = GoogleMapType.Normal;
                Map1.CustomOverlays["GoogleMap"].IsVisible = true;
            }
            else if (selectedMap == "GoogleSatHybrid")
            {
                Map1.CustomOverlays["GoogleSatHybridMap"].IsVisible = true;
            }
            else if (selectedMap == "GoogleTerrain")
            {
                Map1.CustomOverlays["GoogleTerrainMap"].IsVisible = true;
            }
            else if (selectedMap == "BingMap")
            {
                Map1.CustomOverlays["BingMap"].IsVisible = true;
            }
            else if (selectedMap == "BingSat")
            {
                Map1.CustomOverlays["BingSatelliteMap"].IsVisible = true;
            }
            else if (selectedMap == "BingTerrain")
            {
                Map1.CustomOverlays["BingTerrainMap"].IsVisible = true;
            }
            else if (selectedMap == "WorldMapKit")
            {
                Map1.CustomOverlays["WMKMap"].IsVisible = true;
            }
        }
    }
}
